/**
 * jQuery Mobile - Faith of Life Network
 *
 * @url		http://github.com/faithoflifedev/Faith-of-Life-Network
 * @author	Faith of Life Developer <faithoflifedev@gmail.com>
 * @version	2.0.3
**/

var is_online = true;

window.addEventListener(
	'load', 
	function () 
	{
    	document.addEventListener(
    		'deviceready', 
    		onDeviceReady,
    		false
    	);
    	
    	onDeviceReady();
	}, 
	false
);

$( '#pg_events' ).live(
    'pageinit',
    startup
);
    
$( '#pg_map' ).live(
    'pageshow',
    pg_map
);
    
$( '#pg_donate' ).live(
    'pageinit',
    pg_donate
);
    
$( '#pg_about' ).live(
    'pageinit',
    pg_about
);

function startup()
{
	$( 'div.ui-page' ).live(
		"swipeleft", 
		function( event )
		{
			var nextpage = $( this ).next( 'div[data-role="page"]' );

			// swipe using id of next page if exists
			if ( nextpage.length > 0 ) 
			{
				$.mobile.changePage( 
					nextpage, 
					{
                    	transition: 'slide',
                    	reverse: false
                	} 
                );
			}
		}
	);

	$( 'div.ui-page' ).live(
		"swiperight", 
		function( event )
		{
			var prevpage = $( this ).prev( 'div[data-role="page"]' );
		
			// swipe using id of next page if exists
			if ( prevpage.length > 0 ) 
			{
				$.mobile.changePage( 
					prevpage, 
					{
                    	transition: 'slide',
                    	reverse: true
                	}
                );
			}
		}
	);
		
	$( '#continue' ).click(
		function( event )
		{
			$( '#dlg_leaving' ).dialog ( 'close' );
		}
	);

    $( '#refreshEvents' ).click( pg_events );
    
    pg_events();
}

function onDeviceReady()
{
   	var networkState = navigator.network.connection.type;
    
    if ( networkState == Connection.ETHERNET || networkState == Connection.WIFI || networkState == Connection.CELL_2G || networkState == Connection.CELL_3G || networkState == Connection.CELL_4G )
    {    
        is_online = true;
    }
    else
    {
        is_online = false;
    }
    
    document.addEventListener( 
	    "online", 
    	function( event )
		{
    		is_online = true;
    
	    	$( '#fln_header_about' ).show();
    		$( '#website' ).show();
    		$( '#email' ).show();
		}, 
		false 
	);
    
    document.addEventListener( 
    	"offline", 
    	function( event )
		{
    		is_online = false;
    
    		navigator.notification.alert(
        		'The Faith of Life Network app is switching to offline functionality.',
        		function()
        		{
            		$.mobile.changePage( $( '#pg_about' ) );
        		},
        		'Going Offline'
    		);
		},
    	false 
    );   
    
    document.addEventListener(
    	"backbutton", 
    	function( event )
    	{
    		navigator.app.exitApp();
    	}, 
    	false
    );
    
}

function pg_events()
{
    $( '#fln_events li' ).live(
        'click',
        function()
        {
            $( '#continue' ).attr( 'href', $( this ).data( "identity" ) );
        }
    );
    
	$( '#fln_events_none' ).hide();
    
    $.mobile.showPageLoadingMsg();
    
    $.yql(
        "select * from feed where url = 'http://www.faithoflife.net/index.php?option=com_jevents&task=modlatest.rss&format=feed&type=rss&modid=23'",
        {},
        function ( response )
        {
        	var arr_data = [];
        	
            if ( ! response.query.results )
            {
            	$( '#fln_events' ).parent().append( '<p>There are no events listed at this time.</p>' );
            
            	return;
            }
            
            if ( response.query.results.item.length == undefined )
            	arr_data.push( response.query.results.item );
          	else
            	arr_data = response.query.results.item;
            
            var dt = null;
          
            var last_dt = null;
          
            var title = null
           	
            $.mobile.hidePageLoadingMsg();
          
           	$( '#fln_events' ).empty();
            
            $.each(
            	arr_data,
                function( index, item )
                {
                    var arr_title = item.title.split( ' : ' );
                 
                    dt = arr_title[0];
                 
                    title = arr_title[1];
                 
                    if ( dt != last_dt )
                    {
                        $( '#fln_events' ).append( "<li data-role='list-divider'>" + dt + "</li>" );
                         
                		last_dt = dt;
                    }
                 
                	$( '#fln_events' ).append( '<li data-identity="' + item.link + '"><a href="#dlg_leaving" data-rel="dialog" data-transition="flip">' + title + '<p>' + item.description + '</p></a></li>' );
                }
            );
          
            $( "#fln_events" ).listview( "refresh" );
        }
    );    
}

function pg_map()
{
	$( '#map_canvas' ).width( $( document ).width() - $('#map_canvas').position().left - $('#map_canvas').offset().left );
   
    $( '#map_canvas' ).height( $( document ).height() - $( '#map_canvas' ).position().top - 30 );

    $( '#map_canvas' ).gmap({ 'center': '43.650652,-79.708003' });
    
    $( '#map_canvas' ).gmap().bind(
    	'init', 
    	function( event, map ) 
    	{ 
        	$( '#map_canvas' ).gmap(
        		'addMarker', 
        		{ 
        		'position': '43.650652,-79.708003', 
        		'bounds': true,
        		} 
        	).click(
        		function() 
        		{
				    $( '#map_canvas' ).gmap( 'openInfoWindow', { 'content': '<div align="center" style="color: #000000"><img width="200" src="images/building.jpg" /><br/><br/>7150 Edwards Blvd. Mississauga, Ontario</div>' }, this );
        		}
			);                                                                                                                                                                                                                
    
		    $( '#map_canvas' ).gmap( 'option', 'zoom', 15 );
		    
		    $( '#map_canvas' ).gmap( 'option', 'mapTypeId', google.maps.MapTypeId.HYBRID );
		}
	);
}

function pg_donate()
{
    $( '#fln_type li' ).live(
        'click',
        function()
        {
            $( '#continue' ).attr( 'href', $( this ).data( "identity" ) );
        }
    );
}

function pg_about()
{
    if ( ! is_online )
    {
        $( '#fln_header_about' ).hide();
        $( '#website' ).hide();
        $( '#email' ).hide();
    }
}